<template>
  <q-page>
    <div class="full-width">
      <div class="dapps">
        <div class="favorites-block">
          <div class="favorites-block-content">
            <div class="header-1">Favorites</div>
            <div v-if="favorites.length">
              <draggable
                class="favorites-row"
                v-model="favorites"
                group="apps"
                @start="drag = true"
                @end="drag = false"
              >
                <div
                  class="favoirte-dapp"
                  v-for="app in favorites"
                  :key="app.id"
                  @click="selectDapp(app)"
                >
                  <div class="favorite-dapp-logo-button">
                    <div
                      class="app"
                      :style="
                        `backgroundImage: url('${app.imgixImageUrl ||
                          app.imageUrl}')`
                      "
                    ></div>
                  </div>
                  <div class="favorite-dapp-title-container">
                    <div class="favorite-dapp-title">{{ app.name }}</div>
                  </div>
                </div>
              </draggable>
            </div>
            <div class="no-favorites" v-else>
              <div id="notloggedin" v-if="user === null">
                <div class="no-favorites-card wavy">
                  <div class="no-favorites-instruct">
                    <div class="no-favorites-h1" @click="signIn">
                      Log in to save your favorites.
                      <br />
                    </div>
                  </div>
                </div>
              </div>
              <div id="loggedin" v-else>
                <div class="no-favorites-card wavy">
                  <div class="no-favorites-instruct">
                    <div class="no-favorites-h1">
                      Launch your favorite dapps in a jiffy.
                      <br />
                    </div>
                    <div class="no-favorites-h2">
                      Just select one from below and tap on the star to add it
                      here.
                    </div>
                  </div>
                </div>
              </div>
            </div>
          </div>
        </div>
        <div class="categories">
          <div
            class="category-type"
            v-for="(category, index) in filteredAppsByCategory"
            :key="category.label"
          >
            <div class="cat-title-and-button">
              <div class="category-type-title">{{ category.label }}</div>

              <q-btn
                flat
                style="padding:0px"
                class="more-button"
                :to="`/webby/category/${index}`"
                v-if="showMoreButton(category.apps.length)"
              >
                <div class="more-button-text">More &gt;</div>
              </q-btn>
            </div>
            <div class="dapp-category-grid">
              <template v-for="app in splitCategoryForGrid(category.apps)">
                <div class="dapp-2" :key="app.id" @click="selectDapp(app)">
                  <div
                    class="category-dapp-logo-outlined"
                    :style="
                      `backgroundImage: url('${app.imgixImageUrl ||
                        app.imageUrl}')`
                    "
                  ></div>
                  <div class="category-dapp-details">
                    <div class="category-dapp-title">{{ app.name }}</div>
                    <div class="category-dapp-description">
                      {{ app.description }}
                    </div>
                  </div>
                </div>
              </template>
            </div>
          </div>
          <div class="bottom-color-block"></div>
        </div>
      </div>
    </div>
    <q-dialog v-model="dialog" height="80%" :style="{ width: appCardWidth }">
      <app-card :app="activeDapp" />
    </q-dialog>
  </q-page>
</template>

<script>
import { mapActions, mapGetters, mapState } from "vuex";
import { userSession } from "boot/blockstack";
import AppCard from "../components/AppCard";
import chunk from "lodash.chunk";
import draggable from "vuedraggable";
// import { showBlockstackConnect } from "@blockstack/connect";

export default {
  name: "Dapps",
  components: {
    AppCard,
    draggable
  },
  data() {
    return {
      ratingModel: 0,
      showMenu: false,
      defaultProfilePic: "statics/avatar-placeholder.png",
      activeDapp: {},
      loading: false,
      dialog: false
    };
  },
  computed: {
    ...mapState(["user", "favoriteIDs", "dappFaves", "categories", "apps"]),
    ...mapGetters({
      // apps: "apps",
      // categories: "categories",
      filteredAppsByCategory: "filteredAppsByCategory",
      dappFaves: "favorites"
      // favoriteIDs: "favoriteIDs",
      // user: "user"
    }),
    favorites: {
      get() {
        return this.dappFaves;
      },
      async set(val) {
        let newFaves = val.map(fave => fave.id);
        this.setFaves(newFaves);
        userSession
          .putFile("webby-favorites.json", JSON.stringify(newFaves))
          .then(() => {
            console.log("favorites updated");
          })
          .catch(err => {
            console.log("Error saving favorites: ", err);
          });
      }
    },
    appCardWidth() {
      if (this.$q.screen.xs) {
        return "100%";
      } else {
        return "700px";
      }
    },
    appsByCategory() {
      return this.categories.map(category => ({
        label: category,
        apps: this.apps.filter(app => app.category === category)
      }));
    }
  },
  methods: {
    ...mapActions({
      init: "init",
      setFaves: "setFaves"
    }),
    showPageOptions() {
      this.showPageModal = true;
    },
    splitCategory(arr) {
      let results = chunk(arr, 3);
      return results;
    },
    splitCategoryForGrid(arr) {
      let chunksize = 9;
      if (this.$q.screen.xs) {
        chunksize = 4;
      } else if (this.$q.screen.gt.xs && this.$q.screen.lt.lg) {
        chunksize = 6;
      } else {
        chunksize = 9;
      }

      return arr.slice(0, chunksize);
    },
    showCategory(apps) {
      return apps.length;
    },
    showMoreButton(size) {
      let chunksize = 9;
      if (this.$q.screen.xs) {
        chunksize = 4;
      } else if (this.$q.screen.gt.xs && this.$q.screen.lt.lg) {
        chunksize = 6;
      } else {
        chunksize = 9;
      }

      if (size > chunksize) {
        return true;
      } else {
        return false;
      }
    },
    selectDapp(data) {
      this.activeDapp = data;
      this.dialog = true;
    }
  }
};
</script>
<style>
.q-button-fix {
  padding: 0px;
}
</style>
